"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function _path() {
    return data;
  };

  return data;
}

function _server() {
  const data = require("@nocobase/server");

  _server = function _server() {
    return data;
  };

  return data;
}

var _Workflow = _interopRequireDefault(require("./models/Workflow"));

var _Execution = _interopRequireDefault(require("./models/Execution"));

var _actions = _interopRequireDefault(require("./actions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

class WorkflowPlugin extends _server().Plugin {
  load(options = {}) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const db = _this.app.db;
      db.registerModels({
        WorkflowModel: _Workflow.default,
        ExecutionModel: _Execution.default
      });
      yield db.import({
        directory: _path().default.resolve(__dirname, 'collections')
      });
      (0, _actions.default)(_this.app); // [Life Cycle]:
      //   * load all workflows in db
      //   * add all hooks for enabled workflows
      //   * add hooks for create/update[enabled]/delete workflow to add/remove specific hooks

      _this.app.on('beforeStart', /*#__PURE__*/_asyncToGenerator(function* () {
        const _db$getCollection = db.getCollection('workflows'),
              model = _db$getCollection.model;

        yield model.mount();
      })); // [Life Cycle]: initialize all necessary seed data


      _this.app.on('db.init', /*#__PURE__*/_asyncToGenerator(function* () {})); // const [Automation, AutomationJob] = database.getModels(['automations', 'automations_jobs']);
      // Automation.addHook('afterCreate', async (model: AutomationModel) => {
      //   model.get('enabled') && await model.loadJobs();
      // });
      // Automation.addHook('afterUpdate', async (model: AutomationModel) => {
      //   if (!model.changed('enabled' as any)) {
      //     return;
      //   }
      //   model.get('enabled') ? await model.loadJobs() : await model.cancelJobs();
      // });
      // Automation.addHook('beforeDestroy', async (model: AutomationModel) => {
      //   await model.cancelJobs();
      // });
      // AutomationJob.addHook('afterCreate', async (model: AutomationJobModel) => {
      //   await model.bootstrap();
      // });
      // AutomationJob.addHook('beforeDestroy', async (model: AutomationJobModel) => {
      //   await model.cancel();
      // });

    })();
  }

  getName() {
    return this.getPackageName(__dirname);
  }

}

exports.default = WorkflowPlugin;