"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

const MODE_BITMAP = {
  CREATE: 1,
  UPDATE: 2,
  DESTROY: 4
};
const MODE_BITMAP_EVENTS = new Map();
MODE_BITMAP_EVENTS.set(MODE_BITMAP.CREATE, 'afterCreate');
MODE_BITMAP_EVENTS.set(MODE_BITMAP.UPDATE, 'afterUpdate');
MODE_BITMAP_EVENTS.set(MODE_BITMAP.DESTROY, 'afterDestroy'); // async function, should return promise

function bindHandler(callback) {
  const _this$config = this.config,
        condition = _this$config.condition,
        changed = _this$config.changed;
  return (data, options) => {
    // NOTE: if no configured fields changed, do not trigger
    if (changed && changed.length && changed.every(name => !data.changed(name))) {
      return;
    } // NOTE: if no configured condition match, do not trigger


    if (condition && condition.$and.length) {// TODO: check all conditions in condition against data
      // const calculation = toCalculation(condition);
    }

    return callback({
      data: data.get()
    }, options);
  };
}

var _default = {
  name: 'collection',

  on(callback) {
    const database = this.constructor.database;
    const _this$config2 = this.config,
          collection = _this$config2.collection,
          mode = _this$config2.mode;
    const Collection = database.getCollection(collection);

    if (!Collection) {
      return;
    }

    var _iterator = _createForOfIteratorHelper(MODE_BITMAP_EVENTS.entries()),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        let _step$value = _slicedToArray(_step.value, 2),
            key = _step$value[0],
            event = _step$value[1];

        if (mode & key) {
          var _Collection$model$opt;

          if (!((_Collection$model$opt = Collection.model.options.hooks[event]) === null || _Collection$model$opt === void 0 ? void 0 : _Collection$model$opt.find(item => item.name && item.name === this.getHookId()))) {
            Collection.model.addHook(event, this.getHookId(), bindHandler.call(this, callback));
          }
        } else {
          Collection.model.removeHook(event, this.getHookId());
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  },

  off() {
    const database = this.constructor.database;
    const _this$config3 = this.config,
          collection = _this$config3.collection,
          mode = _this$config3.mode;
    const Collection = database.getCollection(collection);

    if (!Collection) {
      return;
    }

    var _iterator2 = _createForOfIteratorHelper(MODE_BITMAP_EVENTS.entries()),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        let _step2$value = _slicedToArray(_step2.value, 2),
            key = _step2$value[0],
            event = _step2$value[1];

        if (mode & key) {
          Collection.model.removeHook(event, this.getHookId());
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }

};
exports.default = _default;